#include <Application.h>
#include <OS.h>
#include <Window.h>
#include "Window1.h"
#include "Window2.h"
#include "Window3.h"
#include "Window4.h"
#include "Window5.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <Entry.h>
#include <Node.h>
#include <Path.h>
#include <NodeInfo.h>
#include <File.h>
#include <Directory.h>
#include <SymLink.h>
#include <Alert.h>
#include <StopWatch.h>
#include <scsi.h>
#include <CAM.h>
#include "MediaInfo.h"
#include <signal.h>
#include <Bitmap.h>
#include "SettingsWindow.h"
#include <FilePanel.h>
#include "ProtocolWindow.h"
#include "M3UList.h"

#ifndef _Application1_

class Application1 : public BApplication
{
public:
	Application1 ();
	~Application1 (void);


	virtual void ReadyToRun(void);
	virtual bool QuitRequested(void);
	virtual void MessageReceived(BMessage *message);
	virtual void RefsReceived(BMessage *message);
	virtual void AboutRequested(void);
	Window1 * window1;
	Window2 * window2;
	Window3 * window3;
	Window4 * window4;
	Window5 * window5;
	SettingsWindow *settingswindow;
	
bool FileExists(BEntry *entry);
bool FileExists(BEntry entry);
bool FileExists(BFile *file);
bool FileExists(char *filename);
bool FileExists(const char *filename);
bool IsProject(bool show_alert);
	
status_t GetMultisessionSectors(int32 &start, int32 &end);
	
	
bool CreateEntry(char *pathname, char *entryname);
void ShowFolder(bool audio=false);
void Update_path();
void MakeImage();
bool GetCDRDevices();
bool OnlyFiles();
void BurnAudio();
void BlankRW(char *mode);
bool GetImageSize();
void ChangePauses();
void Update_DATA_AUDIO();
void HideStatus();
void ShowStatus(const char *text);
void MakeImage_NOSTREAMING();
void SetStatus(const char *text);
void MoveUp();
void MoveDown();
void lookup_devices(const char *path);
bool BurnImage(BString filename);
bool ReadImage(BString filename, bool alloweject=true);
void HideStatus2();
void ShowStatus2(const char *text, thread_id Thread);
void SetStatus2(const char *text, thread_id Thread);
void SetStatus2Info(const char *text, const char *leading="");
bool MakeImageOnly(BString filename);
void eject_media(const char * dev);
void CopyOnTheFly();
void DoAudioMenu();
void DoDataMenu();
void Calculate_time();
void GetFolder(BDirectory dir);
void UpdateTrackNumbers();
float ItemLength(BStringItem *item);
void SetPercentage(float percentage);
int DeviceStatus(const char *path);
void CopyDataCD();
int UnmountBFSImage(const char *mountpoint);
int MountBFSImage(const char *filename, const char *mountpoint);
void DeleteAllIn(BDirectory dir);
status_t WaitForDisc(const char *device);

void SaveSettings();
void ReadSettings();


void ShowOpenPanel();
void ShowSavePanel();
void ShowFolderPanel();
void ShowExportPanel(BMessage *msg);

void LoadProject(BEntry *entry);
void SaveProject(BEntry *entry);
void NewProject();
void SetAsStandardProject();
void ExportAsM3U(BEntry *entry);
void ExportAsAPML(BEntry *entry);
void ExportAsFileList(BEntry *entry);
void GetEntryNamesIn(BDirectory dir, M3UList *list);
void AddToRecent(BString *filename);
void ShowRecentProjects();
void RefreshStatusView();

void RemoveInfFiles();
const char *GenerateInfFilename(int32 index);
void ExportAsInf(BEntry *entry, int32 index);
void SaveCDTEXTAlbum();
int MakeMKISOFSCommandline(const char **args, const char *filename, bool printsize=false);

// bfs
bool MakeBFSImage(const char *filename);

// mkisofs-file system
bool MakeMKISOImage(const char *filename);

void GetSize(BDirectory dir);
void CheckIfProjectChanged();
bool CheckCDSize();

int ReadAudioCD();

void PopulateFoldersMenu();

//void AddFileTrackNumbers();
//void RemoveFileTrackNumbers();

typedef struct  {
	bool 	_burnproof;
	bool 	_simulation;
	bool 	_fixate;
	bool 	_streaming;
	bool 	_ejectwriter;
	bool 	_ejectreader;
	bool 	_normalize;
	bool 	_writeDAO;
	bool 	_allowoverburning;
	int 	_recorderspeed;
	int 	_recorderdevice;
	int 	_readerdevice;
	int 	_filesystem;
	int	_filesystemBootCD;
	char 	_volumename[64];
	char 	_volumenameBootCD[64];
	char 	_cdtype;
	char 	_imagename[300];
	char	_publisher[128];
	char	_preparer[128];
	char	_application[128];
	char	_heliospath[300];
	char	_lastprojectfile[300];
	bool 	_onthefly;
	bool	_writeCDText;
	bool	_protectAudioCD;
	char	_eltoritoimage[200];
	char	_cdtextalbum[129];
// window position settings
	BRect 	_window1position,		// main window
		_window2position,		// rename and new folder window
		_window4position,		// image window
		_settingswindowposition,	// settings window
		_cdrecordlogwindow,		// ...
		_mkisofslogwindow;		// ...
	char	_s_currentpath[500];
	char	_s_basepath[500];
	int	_s_filesystem;		// menuitem index
	char 	_s_volumename[64];
	char 	_s_cdtype;		// 0 for data, 1 for audio
	char	_s_publisher[128];
	char	_s_preparer[128];
	char	_s_application[128];
	char	_recentprojects[5][500];	
} settings_struct;

settings_struct settings;


struct projectStruct {
	char	_currentpath[500];
	char	_basepath[500];
	int	_filesystem;		// menuitem index
	char 	_volumename[64];
	char 	_cdtype;		// 0 for data, 1 for audio
	char	_publisher[128];
	char	_preparer[128];
	char	_application[128];
	char	_itemBlocksFollowing;
};

struct audioBlock {
	char	_cdtext_title[161];
	float	_pause;
	char	_indexList[600];
	char	_filename[600];
	size_t	_length;
};

projectStruct 	*currentproj;
BMessage	listview_content,
		application_settings;

char donow;
BFilePanel	*filepanel;
BStringView	*filepanelSV;
BString		currentproject;
BString base_folder;
BString current_folder;
BString cdir;
BString pathdisplay;
const char **devices;
const char **devicepaths;
long imagesize;
BStopWatch *watch;
bool addershows;
int cdrecord_priority, number;
BString SCSI_IDE;

off_t imgsize;
int32 files, directories;
//ToolTip *tooltip1, *tooltip2;
//BBitmap *bmp;

int32 filename_col;
bool has_project_changed;
bool save_and_quit;
bool is_all_showing;

typedef struct track_info {
	char	type[32];
	int		size;
} track_info;

ProtocolWindow	*cdrecord_output,
			*mkisofs_output;


};

#define _Application1_
#endif
