#ifndef _CDTEXT_H_
#define _CDTEXT_H_

#include <File.h>

struct textpack {
	uchar	pack_type;	/* Pack Type indicator	*/
	char	track_no;	/* Track Number (0..99)	*/
	char	seq_number;	/* Sequence Number	*/
	char	block_number;	/* Block # / Char pos	*/
	char	text[12];	/* CD-Text Data field	*/
	char	crc[2];		/* CRC 16		*/
};

class CDTextFile : BFile {
	public:
		CDTextFile(const BEntry *entry);
		~CDTextFile();
		
		// CD-Text Titles
		void AddTitles(const char **title, int title_number);
		const char *GetTitleAt(int32 index);
		
		// CD-Text Album Tag
		void SetAlbum(const char *album);
		const char *GetAlbum();
		
	private:

		textpack CreatePack(uchar pti, char data[12]);
		void AddChunk(textpack);
		
		uchar	hbuf[4];		// keeps information about size of contained data
		char	title[160];

};


#endif