#include <Application.h>
#include "ListView1.h"
#include <PopUpMenu.h>
#include <MenuItem.h>
#include "Defines.h"
#include <ScrollBar.h>
#include <stdio.h>
#include "AudioRow.h"
#include <stdlib.h>

ListView1::ListView1()
 : BColumnListView(BRect(0,0, 302, 213-B_H_SCROLL_BAR_HEIGHT), "listview", B_FOLLOW_ALL_SIDES, B_WILL_DRAW|B_FULL_UPDATE_ON_RESIZE, B_NO_BORDER, true)
{


cmenu=new BPopUpMenu("context-menu",false,false);
statusView=new StatusView(this);

deleteItem=new BMenuItem(TDELETE,new BMessage(DELETE_FILE_MSG));
newfolderItem=new BMenuItem(TNEWFOLDER,new BMessage(NEW_FOLDER_MSG));
renamefileItem=new BMenuItem(TRENAME,new BMessage(RENAME_FILE_MSG));
moveupItem=new BMenuItem(TMOVEUP,new BMessage(MOVE_UP_MSG));
movedownItem=new BMenuItem(TMOVEDOWN,new BMessage(MOVE_DOWN_MSG));
indexItem=new BMenuItem(TSETINDICES,new BMessage(SET_INDICES_MSG));
splitItem=new BMenuItem(TSPLITTRACK,new BMessage(SPLIT_TRACK_MSG));
CDTEXTTitleItem=new BMenuItem(TCDTEXTTITLE, new BMessage(SETCDTEXTTITLE_MSG));
//cmenu->ItemAt(0)->SetTarget(be_app_messenger);
cmenu->SetTargetForItems(be_app_messenger);
SetColor(B_COLOR_SELECTION,(rgb_color){90,90,90,255});
SetColor(B_COLOR_NON_FOCUS_SELECTION,(rgb_color){150,150,150,255});
SetColor(B_COLOR_BACKGROUND,(rgb_color){255,255,255,255});
SetColor(B_COLOR_ROWS_1,Color(B_COLOR_BACKGROUND));
SetColor(B_COLOR_ROWS_2,Color(B_COLOR_BACKGROUND));
SetColor(B_COLOR_ROWS_3,Color(B_COLOR_BACKGROUND));
SetColor(B_COLOR_ROWS_4,Color(B_COLOR_BACKGROUND));
SetColor(B_COLOR_ROWS_5,Color(B_COLOR_BACKGROUND));
SetColor(B_COLOR_ROWS_6,Color(B_COLOR_BACKGROUND));
SetColor(B_COLOR_ROWS_7,Color(B_COLOR_BACKGROUND));
SetColor(B_COLOR_ROWS_8,Color(B_COLOR_BACKGROUND));
SetColor(B_COLOR_ROW_DIVIDER,Color(B_COLOR_BACKGROUND));
SetColorBands(8);
}

void ListView1::AllAttached() {
	SetEditMode(false);
	SetTarget(this);
	MakeFocus(false);
	SetColumnFlags((column_flags)(B_ALLOW_COLUMN_MOVE | B_ALLOW_COLUMN_RESIZE | B_ALLOW_COLUMN_POPUP | B_ALLOW_COLUMN_REMOVE));
	SetMouseTrackingEnabled(false);
	AddStatusView(statusView);
	SetSelectionMessage(new BMessage('slct'));
}

ListView1::~ListView1(void) {
	delete cmenu;
}


void
ListView1::SelectionChanged(void) {

	be_app->PostMessage('mm05');
	printf("SELECTION_CHANGED\n");
}

void
ListView1::KeyDown(const char *bytes, int32 numByte)
{

if (bytes[0]==B_DELETE) 
     be_app->PostMessage(DELETE_FILE_MSG);

BColumnListView::KeyDown(bytes,numByte);

}

void ListView1::SetDataCDList() {
	while (CountRows()>0) RemoveRow(0);
	while (CountColumns()>0) {
		BColumn	*col=ColumnAt(0);
		RemoveColumn(col);
		delete col;
	}
	
	SetSortingEnabled(true);
	AddColumn(new BBitmapColumn(FILEICONCOLUMN_TITLE,18,18,18, B_ALIGN_CENTER), ICON_FIELD);
	AddColumn(new BFileColumn(FILENAMECOLUMN_TITLE, 200, 60, 900,0), FILENAME_FIELD);
	AddColumn(new BSizeColumn(SIZECOLUMN_TITLE, 57, 20, 100,B_ALIGN_RIGHT), SIZE_FIELD);
	ColumnAt(FILENAME_FIELD)->SetEditFlags(B_EDIT_EXIT_RETURN);
	ColumnAt(FILENAME_FIELD)->SetColumnFlags(ColumnAt(FILENAME_FIELD)->GetColumnFlags() | B_ALLOW_COLUMN_EDIT);
	ColumnAt(ICON_FIELD)->SetColumnFlags(B_ALLOW_COLUMN_NONE);
	ColumnAt(ICON_FIELD)->SetShowHeading(false);
	SetSortColumn(ColumnAt(FILENAME_FIELD), false, true);
}


void ListView1::SetAudioCDList() {
	while (CountRows()>0) RemoveRow(0);
	while (CountColumns()>0) {
		BColumn	*col=ColumnAt(0);
		RemoveColumn(col);
		delete col;
	}

	SetSortingEnabled(false);
	AddColumn(new BIntegerColumn(TRACKNUMBERCOLUMN_TITLE, 35, 35, 35, B_ALIGN_RIGHT), TRACKNUMBER_FIELD);
	AddColumn(new BStringColumn(PREGAPCOLUMN_TITLE, 50, 50, 50,1, B_ALIGN_RIGHT), PREGAP_FIELD);
	AddColumn(new BStringColumn(TRACKNAMECOLUMN_TITLE, 200, 60, 900,0), TRACKNAME_FIELD);
	AddColumn(new BStringColumn(LENGTHCOLUMN_TITLE, 80, 70, 70,0, B_ALIGN_RIGHT), LENGTH_FIELD);
	AddColumn(new BSizeColumn(BYTESCOLUMN_TITLE, 50, 50, 50,B_ALIGN_RIGHT), BYTES_FIELD);
	AddColumn(new BStringColumn(INDEXCOLUMN_TITLE, 150, 50, 250,0), INDEX_FIELD);
	AddColumn(new BStringColumn(CDTEXTCOLUMN_TITLE, 150, 50, 250,0), CDTEXT_FIELD);
}


void ListView1::SetListMode(int32 mode) {
	CDMode=mode;
	switch(mode) {
		case DATACD_INDEX:	SetDataCDList(); break;
		case AUDIOCD_INDEX:	SetAudioCDList(); break;
		case BOOTABLECD_INDEX:	SetDataCDList(); break;
		default: 	SetDataCDList(); break;
	}
}

bool ListView1::InitiateDrag(BPoint point,  bool wasSelected) {
printf("InitiateDrag():");
	
	point.PrintToStream();
	BRow	*row=FocusRow();
/*	
	if ((CDMode==DATACD_INDEX) || (CDMode==BOOTABLECD_INDEX)) {	// yes? then we are not in audio mode
		folderRow=new FolderRow(((FolderRow *)row)->GetFilename(),
						((FolderRow *)row)->IsFolder(),
						((FolderRow *)row)->GetBitmap());
	} else */
	if (CDMode==AUDIOCD_INDEX){
		audioRow=new AudioRow(((AudioRow *)row)->GetTrackNumber(),((AudioRow *)row)->GetFilename(),
						((AudioRow *)row)->GetPregap(),
						((AudioRow *)row)->GetBytes(),
						((AudioRow *)row)->GetLength() );
	}
	
	BMessage	*message=new BMessage(LISTITEM_DROPPED);
	BRect	rect;
	if (GetRowRect(row, &rect)) {
		void *r=(void *)row;
		message->AddPointer("from", &r);
		if (!((FolderRow *)row)->IsFolder())
			message->AddInt32("index", (int32)IndexOf(row));
		DragMessage(message, rect);
		if (CDMode==AUDIOCD_INDEX)
			RemoveRow(IndexOf(row));
		//delete row;
	}
	return true;
}

void	ListView1::MessageDropped(BMessage *msg, BPoint point) {
printf("MessageDropped():");
	switch(msg->what) {
		case B_MOUSE_DOWN: printf("B_MOUSE_DOWN\n");break;
		case B_SIMPLE_DATA: be_app->PostMessage(msg); break;
		case B_MOUSE_MOVED: printf("B_MOUSE_MOVED\n");break;
		case LISTITEM_DROPPED: 	printf("LISTITEM_DROPPED\n");
				if (CDMode!=AUDIOCD_INDEX) break;
				if (msg->WasDropped()) {
					BPoint where=msg->DropPoint();
					ConvertFromScreen(&where);
					where.PrintToStream();
					BRow *draggedRow=NULL;
					if ((CDMode==DATACD_INDEX) || (CDMode==BOOTABLECD_INDEX)) {	// yes? then we are not in audio mode
						draggedRow=folderRow;
					} else 
					if (CDMode==AUDIOCD_INDEX) {
						draggedRow=audioRow;
					}
					void	*row;
					msg->FindPointer("from", &row);
					//RemoveRow(IndexOf((BRow *)row));
					if (RowAt(where)) {
						int32 index=IndexOf(RowAt(where));
						if (index>0) index--;
						AddRow(draggedRow, index);
					} else					
						AddRow(draggedRow);
				}
				break;
		default:  printf("%ld\n", msg->what);BColumnListView::MessageDropped(msg, point);
	}
}

void	ListView1::MessageReceived(BMessage *message) {
printf("MessageReceived():");
	switch(message->what) {
		case B_MOUSE_DOWN: printf("B_MOUSE_DOWN\n");break;
		case B_SIMPLE_DATA: printf("B_SIMPLE_DATA\n");break;
		case B_MOUSE_MOVED: printf("B_MOUSE_MOVED\n");break;
		case LISTITEM_DROPPED: printf("OWN\n");break;
		default: printf("%ld\n", message->what);BColumnListView::MessageReceived(message);break;
	}
}



void
ListView1::MouseDown(BPoint point){
printf("MouseDown():");
point.PrintToStream();
bool stay=false;
	BMessage *currentMsg = Window()->CurrentMessage();
	if (currentMsg->what == B_MOUSE_DOWN) {
		uint32 buttons = 0;
		currentMsg->FindInt32("buttons", (int32 *)&buttons);

		uint32 modifiers = 0;
		currentMsg->FindInt32("modifiers", (int32 *)&modifiers);
		if (
			(!(buttons & B_SECONDARY_MOUSE_BUTTON))
//			 ||
//				(
//				(!(modifiers & B_SHIFT_KEY)) &&
//				((buttons & B_SECONDARY_MOUSE_BUTTON))
//				)
			
			
			)	{
				BColumnListView::MouseDown(point);
				stay=true;
				}

		if ((buttons & B_SECONDARY_MOUSE_BUTTON)) {
			// secondary button was clicked or control key was down, show menu and return

			//BPopUpMenu *menu = new BPopUpMenu("Info");
			//menu->SetFont(be_plain_font);
			//BuildInfoMenu(menu);
			
			//BMenuItem *selected = menu->Go(ConvertToScreen(where));
			//if (selected)
			//	Window()->PostMessage(selected->Message()->what);
			
			//UMBENENNEN
			// nur ein item selektiert
			if ((CurrentSelection(0)>=0) && (CurrentSelection(1)<0))
				{
				renamefileItem->SetEnabled(true);
				indexItem->SetEnabled(true);
				splitItem->SetEnabled(true);
				} else
				{
				renamefileItem->SetEnabled(false);
				indexItem->SetEnabled(false);
				splitItem->SetEnabled(false);
				}
			//LÖSCHEN
			if (!(CurrentSelection(0)<0))
				deleteItem->SetEnabled(true); else
				deleteItem->SetEnabled(false);
			//MOVE UP/DOWN
			if (CurrentSelection(0)<0)
				{
				moveupItem->SetEnabled(false);
				movedownItem->SetEnabled(false);
				CDTEXTTitleItem->SetEnabled(false);
				} else
				{
				moveupItem->SetEnabled(true);
				movedownItem->SetEnabled(true);
				CDTEXTTitleItem->SetEnabled(true);
				}
			cmenu->Go(ConvertToScreen(point),true, stay, false);

		//	return;
		}


	}

}

int32 ListView1::iCountItems() {
	return this->CountRows();
}

void ListView1::iMakeEmpty() {
	this->Clear();
}


void ListView1::AddFile(const char *name, size_t size=0) {
}

void ListView1::AddFolder(const char *name, size_t size=0) {
}

void ListView1::AddAudioTrack(const char *name, size_t size, float length, int32 **indeces, const char *title="") { 		// length in seconds
}


bool ListView1::IsSelected(int32 i) {
	BRow	*lastSelected=BColumnListView::CurrentSelection();
	
	do {
		if (lastSelected!=NULL) {
			if (IndexOf(lastSelected)==i) return true;
		lastSelected=BColumnListView::CurrentSelection(lastSelected);
		}
	} while (lastSelected!=NULL);
	return false;
}


int32 ListView1::SelectionCount() {
	return CountRows();
}

void ListView1::RemoveRow(int32 index) {
	BRow *row=RowAt(index);
	BColumnListView::RemoveRow(row);
	delete row;
}

BRow *ListView1::CurrentSelection(int32 index) {
	int32 count=-1;
	BRow	*lastSelected=NULL;
	
	do {
		count++;
		lastSelected=BColumnListView::CurrentSelection(lastSelected);
		if (lastSelected!=NULL) {
			if (count==index) return lastSelected;
		}
	} while (lastSelected!=NULL);
	return NULL;
}

int32 ListView1::iCurrentSelection(int32 index) {
	int32 i;
	
	if (CurrentSelection(index)==NULL) i=-1; 
	else i=IndexOf(CurrentSelection(index));
	return i;
}


void	ListView1::EndEditing() {
	if (!GetEditMode()) return;
	printf("EndEditing()\n");
	BColumnListView::EndEditing();
}
