#ifndef _PROTOCOLWINDOW_H_
#define _PROTOCOLWINDOW_H_

#include <Window.h>
#include <TextView.h>
#include <ScrollView.h>
#include <Rect.h>
#include <MenuBar.h>
#include <Menu.h>
#include <MenuItem.h>

class ProtocolView : public BTextView {
public:
	ProtocolView(BRect frame, const char *name, BRect textRect, uint32 resizingMode, uint32 flags, int stream);
	~ProtocolView();
	
	void 	Start(int stream);
	int	Stop();
	
private:
	void Pulse();
	
	int 	fStream;
	char 	fBuffer[10000];
};

class ProtocolWindow : public BWindow {
public:
	ProtocolWindow(BRect frame, const char *title, window_type type, int stream);
	~ProtocolWindow();
	
	void	Clear();
	void	AddText(const char *string);
	void 	Start(int stream);
	int	Stop();
	
	virtual void MessageReceived(BMessage *msg);
	
private:
	bool	QuitRequested();
	
	ProtocolView	*contentView;
	BScrollView	*scrollView;
	int		fStream;
	BMenu		*mainM;
	BMenuItem	*clearMI,
			*closeMI;
};



#endif