#include <View.h>
#include "StatusView.h"
#include <ScrollBar.h>
#include "Stringtable.h"
#include <stdio.h>
#include <Application.h>
#include <stdlib.h>

StatusView::StatusView(BColumnListView *owner) : BView(BRect(0,0,75,B_H_SCROLL_BAR_HEIGHT-1), "StatusView", B_FOLLOW_LEFT | B_FOLLOW_BOTTOM, B_WILL_DRAW) {
	SetViewColor((rgb_color){219, 219, 219, 255});
	GetFont(&font);
	font.SetSize(9);
	SetFont(&font, B_FONT_SIZE);
	fowner=owner;
	itemString=(char *)malloc(20);
	SetNumberOfItems(0);
	menuPOP=new BPopUpMenu("menuPOP", false, false);
}

StatusView::~StatusView() {
	free(itemString);
}

void StatusView::AddMenuItem(BMenuItem *item) {
	if (item) {
		item->SetTarget(be_app_messenger);
		menuPOP->AddItem(item);
	}
}

void StatusView::RemoveMenuItems() {
	while (menuPOP->CountItems()>0) menuPOP->RemoveItem(0L);
}

void StatusView::SetNumberOfItems(int32 number) {
	sprintf(itemString, "%ld %s", number, (number==1) ? TITEM : TITEMS);
	Invalidate();
}

void StatusView::Draw(BRect updateRect) {
	
	rgb_color	highcolor=HighColor();
	
	SetLowColor(219,219,219,255);
	SetHighColor((rgb_color){152,152,152, 255});
	StrokeLine(BPoint(0,0),BPoint(Bounds().Width(),0));
	StrokeLine(BPoint(Bounds().Width(),1),BPoint(Bounds().Width(),Bounds().Height()-1));
	SetHighColor((rgb_color){255,255,255, 255});
	StrokeLine(BPoint(0,1),BPoint(Bounds().Width()-1,1));
	StrokeLine(BPoint(0,2),BPoint(0,Bounds().Height()-1));
	SetHighColor((rgb_color){0,0,0,255});
	DrawString(itemString, BPoint(4,Bounds().Height()-3));
	SetHighColor(highcolor);
	
	BView::Draw(updateRect);
}

void StatusView::MouseDown(BPoint point) {
	menuPOP->Go(ConvertToScreen(BPoint(Bounds().left, Bounds().bottom+2)), true, true, ConvertToScreen(Bounds()));
}

