#ifndef _STRINGTABLE_H_
#define _STRINGTABLE_H_

#include <InterfaceDefs.h>

#define ABOUT_APPLICATIONNAME		"Helios"
#define ABOUT_VERSIONNUMBER			"1.5"
#define ABOUT_COPYRIGHTSTRING		B_UTF8_COPYRIGHT" by Maurice Michalski"
#define ABOUT_TEXT				"Helios is freeware. Many thanks to these people who helped developing Helios in any way (in alphabetical order): Stephan Aßmus, Philippe Houdoin, Gregor Rosenauer."

#define TSTATUSWINDOWTITLE			"Helios"
#define TSTATUSWINDOWTITLESIMULATION	"Helios - SIMULATION"
#define TWINDOWTITLE   				"Helios CDRECORDer 1.5"

// Settings Window Captions
#define TSETTINGSWINDOWTITLE 		"Settings"
#define TCDRDRIVE   				"CD Writer"
#define TCDREADERLABEL   			"CD Reader"
#define TEJECT					"Eject"
#define TRECORDERSPEED   			"Recording Speed"
#define TBURNPROOF   				"BurnProof"
#define TSIMULATION   				"Simulation"
#define TSTREAMING   				"Data Streaming"
#define TFIXATE   					"Fixate"
#define TNORMALIZE					"Multisession"
#define TDAOMODE					"Use DAO (not TAO)"
#define THELIOSPATH					"Temp. Path:"		// where the temporary files are to be saved (image files...)
#define TPREPARER					"CD Preparer:"
#define TPUBLISHER					"CD Publisher:"
#define TAPPLICATION				"CD Application:"
#define TTWODRIVECOPY				"2-Drive-Copy"
#define TALLOWOVERBURNING			"allow CDs > 80 min"

// BUTTON CAPTIONS
#define TOK   						"Ok"
#define TCANCEL   					"Cancel"
#define TDELETE   					"Remove"
#define TRENAME   					"Rename"
#define TNEWFOLDER   				"New Folder"
#define TMOVEUP   					"Move Up"
#define TMOVEDOWN   				"Move Down"
#define TBLANKRW   					"Blank RW!"
#define TBURNNOW   					"Burn Now!"
#define TABOUT   					"About"B_UTF8_ELLIPSIS
#define TUPDATE   					"Update"
#define TYES   						"Yes"
#define TNO   						"No"
#define TIMAGE   					"Image"B_UTF8_ELLIPSIS
#define TSETTINGS					"Settings"
#define TMOVETOTRASH				"To Trash"
#define TERASE						"Erase"

// Alert Messages
#define TDELETEIMAGEFILE   			"Delete image file?"
#define TXNOTFOUND   				"not found! It has to be installed to use Helios."
#define TNOAUDIOFILE   				"This is no audio file!"
#define TUNKNOWNFILETYPE   			"Unknown File Type"
#define TNOSPACE   					"No space on volume to create image file!"
#define TERROR 						"An error occured!"
#define TNODEVICESFOUND				"No CD-ROM devices found!"
#define TNOCDRDRIVE   				"No CD-R drive found!"
#define TREPLACE_ALERT  			"File already exists.\nDo you want to replace it?"
#define TNOTEXIST_ALERT   			"File does not exist."
#define TSIZE_ALERT					""
#define TONTHEFLYWITHONEDEVICE		"Unfortunately, Helios cannot read an write at the same time with only one drive.\n"\
									"Please check the drive settings in the Settings panel."
#define TAREYOUSURE					"This will erase the project file and all of the links and folder the project itself "\
									"contains. Select \""TMOVETOTRASH"\" if you are not certain.\n"\
									"What shall happen with your project files?"
#define TOVERSIZED					"The project data size is greater than the maximum size of a "\
									"CD. Remove some files or select \""TALLOWOVERBURNING"\" in the preferences panel."


#define TDATACD   					"Data CD"
#define TAUDIOCD   					"Audio CD"
#define TEXTRACD					"CD Extra"
#define TBOOTABLECD					"Bootable CD"
#define TINFO   					"Info"
#define TVOLUMENAME  				"Volume Name"
#define TFILESYSTEM   				"File System"
#define TPAUSE   					"Pause"
#define TRECORDERSETTINGS  			"Recorder Settings"
#define TCREATINGIMAGEFILE   		"Writing Image File"B_UTF8_ELLIPSIS
#define TCOPYINGFILES				"Copying Files"B_UTF8_ELLIPSIS
#define TMOUNTING					"Mounting Image File"B_UTF8_ELLIPSIS
#define TUNMOUNTING					"Unmounting Image File"B_UTF8_ELLIPSIS
#define TBURNINGDATACD   			"Burning Data CD"B_UTF8_ELLIPSIS
#define TBURNINGAUDIOCD   			"Burning Audio CD"B_UTF8_ELLIPSIS
#define TCHECKINGDEVICES   			"Checking Drives"B_UTF8_ELLIPSIS
#define TCALCCDSIZE   				"Calculating Size of CD"B_UTF8_ELLIPSIS
#define TRENAMEITEM   				"Rename"
#define TNEWNAME   					"New Name:"
#define TCREATEFOLDER   			"New Folder"
#define TFOLDERNAME   				"Folder Name:"
#define TBLANKINGCDRW   			"Blanking CD-RW"B_UTF8_ELLIPSIS
#define TTOTALCDSIZE   				"Total CD Size:"
#define TCDLENGTH   				"Total CD Duration:"
#define TESTIMATEDTIME   			"Estimated Time:"
#define TSCANNINGDEVICES   			"[Pick Drive"B_UTF8_ELLIPSIS"]"
#define TADDINGFILES   				"Adding Files"B_UTF8_ELLIPSIS
#define TREMOVINGFILES   			"Removing Files"B_UTF8_ELLIPSIS
#define TTIMEOUT   					"Time Out!"
#define TFIXATING   				"Fixating Disc"B_UTF8_ELLIPSIS
#define TWAITING					"Waiting"B_UTF8_ELLIPSIS
#define TWAITINGFORDISC				"Waiting for Disc"B_UTF8_ELLIPSIS
#define TPERFORMINGOPC				"Adjusting Laser Power"B_UTF8_ELLIPSIS
#define TFINISHEDWRITING			"Finished Writing CD."
#define TFINISHEDERASING			"Finished Blanking CD."
#define TREADINGCD   				"Reading CD Image"B_UTF8_ELLIPSIS
#define TREADINGAUDIO				"Reading Audio Tracks"B_UTF8_ELLIPSIS
#define TFILEERROR   				"File Error"
#define TFILECOUNT					"Number of Files:"
#define TFOLDERCOUNT				"Number of Folders:"
#define TPARENTFOLDER				"Parent Folder"
#define TFOLDER						"Folder"
#define TINDICES					"Indices"
#define TINDICESLIST				"Index List:"
#define TSETINDICES					"Set Indices"
#define TSPLITTRACK					"Split Title"
#define TSPLITOFFSET				"Split At:"
#define TTRACK						"Track"
#define TUNTITLED					"Untitled"
#define TCDTEXTTITLE				"CD Text Title"
#define T___CDTEXTTITLE				"Title:"
#define TCDTEXTALBUMLABEL			"CD Text Album"

// WINDOW4 (IMAGE)
#define TCOPYCD   					"Copy CD"
#define TCREATEIMAGE   				"Create Image"
#define TREADIMAGE   				"Read Image"
#define TBURNIMAGE   				"Burn Now!"
#define TDROPIMAGEFILES   			"Drop Image File Here or Enter Path:"
#define TONTHEFLY   				"On The Fly"
#define TIMAGENAME					"Path To Image File"


// ListView Captions
#define FILEICONCOLUMN_TITLE		"Icon"
#define FILENAMECOLUMN_TITLE		"File Name"
#define SIZECOLUMN_TITLE			"Size"
#define TRACKNUMBERCOLUMN_TITLE		"Track"
#define PREGAPCOLUMN_TITLE			"Pause"
#define TRACKNAMECOLUMN_TITLE		"File Name"
#define LENGTHCOLUMN_TITLE			"Duration"
#define BYTESCOLUMN_TITLE			"Size"
#define INDEXCOLUMN_TITLE			"Indices"
#define CDTEXTCOLUMN_TITLE			"CD Text"

// TOOLTIPS

#define TIP_COPYCD   				"Copies entire CD (not yet implemented)"
#define TIP_CREATEIMAGE   			"Create image of files in list"
#define TIP_READIMAGE   			"Reads an image from a drive"
#define TIP_BURNIMAGE  				"Burns selected image file"
#define TIP_ONTHEFLY   				"Copies a CD from one drive to another (not yet implemented)"
#define TIP_READER   				"Pick the drive to be used for reading"
#define TIP_CDRECORDER   			"Pick the drive to be used for writing"
#define TIP_BURNPROOF   			"Enable only if your drive features (Sanyo-)BurnProof"
#define TIP_SIMULATION   			"Keeps laser off while burning"
#define TIP_STREAMING   			"Creates the image while burning"
#define TIP_EJECT   				"Ejects the CD after burning"
#define TIP_VOLUMENAME   			"Name of CD or session."
#define TIP_PAUSE   				"Pauses of the selected tracks can be entered here (in seconds)"
#define TIP_BLANKRW   				"Blanks the contents of a rewritable CD (CD-RW)"
#define TIP_IMAGEBUTTON   			"Opens a window with additional image options"

// MAIN-MENUITEMS

#define TMI_FILE					"File"
#define TMI_EXPORT					"Export"
#define TMI_EXPORT_M3U				"CL-Amp Playlist"
#define TMI_EXPORT_APML				"APlayer Playlist"
#define TMI_EXPORT_FILELIST			"plain Filelist"
#define TMI_IMAGE					"Image"
#define TMI_COPYCD					"Copy CD"
#define TMI_NEWPROJECT				"New Project"
#define TMI_OPENPROJECT				"Open Project"B_UTF8_ELLIPSIS
#define TMI_OPENRECENT				"Open Recent Project"
#define TMI_SAVEPROJECT				"Save Project"
#define TMI_SAVEPROJECTAS			"Save Project As"B_UTF8_ELLIPSIS
#define TMI_REMOVEPROJECT			"Remove Current Project"
#define TMI_EXIT					"Exit"
#define TMI_READCD					"Read CD Image"B_UTF8_ELLIPSIS
#define TMI_CREATEFILEIMAGE			"Create Image File"B_UTF8_ELLIPSIS
#define TMI_BURNIMAGEFILE			"Burn Image File"B_UTF8_ELLIPSIS
#define TMI_COPYAUDIOCD				"Copy Audio CD"
#define TMI_COPYDATACD				"Copy Data CD"
#define TMI_PREFERENCES				"Settings"B_UTF8_ELLIPSIS
#define TMI_PROTOCOL				"Log Window"
#define TMI_CDRECORDPROTOCOL		"cdrecord"B_UTF8_ELLIPSIS
#define TMI_MKISOFSPROTOCOL			"mkisofs"B_UTF8_ELLIPSIS
#define TMI_ABOUT					"About Helios"B_UTF8_ELLIPSIS
#define TMI_CDRW					"Blank CD-RW"
#define TMI_FASTBLANK				"Entire CD (fast)"
#define TMI_COMPLETEBLANK			"Entire CD (complete)"
#define TMI_UNCLOSESESSION			"Open Last Session"
#define TMI_BLANKSESSION			"Erase Last Session"
#define TMI_STANDARDPROJECT			"Save As Default Project"
#define TMI_CLOSE					"Close"
#define TMI_CLEAR					"Clear"

//Filepanel
#define C_OPEN						"Open"
#define C_SAVE						"Save"
#define C_EXPORT					"Export"
#define C_SELECT					"Select"
#define TFOLDERPANELHELP			"Select folder for virtual CD"

// Multisession alert
#define MULTISESSION_ALERT			"Is this session going to be the first, the last or another session of a multisession disc?"
#define MULTISESSION_ALERT_B2		"first"
#define MULTISESSION_ALERT_B1		"last"
#define MULTISESSION_ALERT_B0		"another"
#define MULTISESSION_FAILS_ALERT		"Could not read inserted multisession disc!"


#define TNOPROJECT					"There is no project loaded!"
#define TASKFORSAVINGCHANGES		"Save changes of current project?"

// AudioCDPanel
#define TWRITECDTEXT				"Write CD Text"
#define TCOPYPROTECTION				"Add SCMS-Copyright"

// DataCDPanel
#define TMULTISESSION				"Multisession-CD"

// BootableCDPanel
#define TELTORITOIMAGE				"Floppyimage"

// StatusView
#define TITEM						"item"
#define TITEMS						"items"

#endif
